=== modified file 'consumption_calculation/weekly_forecast_report_view.xml'
--- consumption_calculation/weekly_forecast_report_view.xml	2016-01-13 15:37:34 +0000
+++ consumption_calculation/weekly_forecast_report_view.xml	2016-02-03 16:35:56 +0000
@@ -124,7 +124,7 @@
         </record>
 
         <record id="action_weekly_forecast_report" model="ir.actions.act_window">
-            <field name="name">Periodical forecast reports</field>
+            <field name="name">Periodical forecast report</field>
             <field name="res_model">weekly.forecast.report</field>
             <field name="view_type">form</field>
             <field name="view_mode">tree,form</field>

=== modified file 'msf_doc_import/initial_stock_inventory.py'
--- msf_doc_import/initial_stock_inventory.py	2016-01-29 15:50:16 +0000
+++ msf_doc_import/initial_stock_inventory.py	2016-02-04 13:13:08 +0000
@@ -47,7 +47,7 @@
         'file_to_import': fields.binary(string='File to import', filters='*.xml',
                                         help="""You can use the template of the export for the format that you need to use. \n The file should be in XML Spreadsheet 2003 format.
                                         \n The columns should be in this order : Product Code*, Product Description*, Location*, Batch, Expiry Date, Quantity"""),
-        'import_error_ok':fields.function(_get_import_error,  method=True, type="boolean", string="Error in Import", store=True),
+        'import_error_ok':fields.function(_get_import_error,  method=True, type="boolean", string="Error in Import", store=False),
     }
 
     def _check_active_product(self, cr, uid, ids, context=None):
@@ -221,6 +221,7 @@
                             'life_date': expiry,
                             'name': batch_name,
                         }, context=context)
+                        to_correct_ok = False
                     elif product.batch_management and not batch_name:
                         batch = False
                         to_correct_ok = True
@@ -388,6 +389,7 @@
 
     _columns = {
         'batch_name': fields.char(size=128, string='Batch name'),
+        'inv_expiry_date': fields.date(string='Invisible expiry date'),
         'to_correct_ok': fields.boolean('To correct'),
         'comment': fields.text('Comment', readonly=True),
         'inactive_product': fields.function(_get_inactive_product, method=True, type='boolean', string='Product is inactive', store=False, multi='inactive'),
@@ -421,6 +423,9 @@
         if 'location_not_found' in vals:
             del vals['location_not_found']
 
+        if not vals.get('expiry_date') and vals.get('inv_expiry_date'):
+            vals['expiry_date'] = vals.get('inv_expiry_date')
+
         batch = vals.get('prod_lot_id')
         expiry = vals.get('expiry_date')
         batch_name = vals.get('batch_name')
@@ -479,6 +484,7 @@
         if hidden_batch_management_mandatory and batch and not expiry:
             expiry = pl_obj.read(cr, uid, batch, ['life_date'], context=context)['life_date']
             comment += _('Please check Expiry Date is correct!.\n')
+            vals['to_correct_ok'] = True
 
         if not comment:
             if vals.get('comment'):
@@ -934,6 +940,15 @@
                 comment += _('Incorrectly formatted expiry date. Batch not created.\n')
             else:
                 comment += _('Batch is missing.\n')
+        elif hidden_batch_management_mandatory and batch and expiry:
+            batch_ids = pl_obj.search(cr, uid, [
+                ('product_id', '=', product.id),
+                ('life_date', '=', expiry),
+                ('name', '!=', batch),
+            ], context=context)
+            if batch_ids:
+                comment += _('Other batch exists for this expiry date')
+                just_warn = True
 
         if not product.batch_management and hidden_perishable_mandatory:
             if expiry and batch:
@@ -948,6 +963,16 @@
                 else:
                     batch = False
                     vals['prodlot_name'] = False
+            if expiry and not batch:
+                batch_ids = pl_obj.search(cr, uid, [
+                    ('product_id', '=', product.id),
+                    ('life_date', '=', expiry),
+                ], context=context)
+                if batch_ids:
+                    batch = False
+                    vals['prodlot_name'] = False
+                    comment += _('Other batch exists for this expiry date')
+                    just_warn = True
 #            if expiry and not batch:
 #                comment += _('Expiry date will be created (with its internal batch).\n')
 #                just_warn = True
@@ -968,11 +993,12 @@
         if hidden_batch_management_mandatory and batch and expiry:
             pl_ids = pl_obj.search(cr, uid, [('name', '=', batch), ('product_id', '=', vals.get('product_id'))], context=context)
             if pl_ids and pl_obj.read(cr, uid, pl_ids[0], ['life_date'], context=context)['life_date'] != expiry:
-                comment += _('Expiry date and batch not consistent.\n')
+                comment += _('Please check expiry date is correct.\n')
                 vals.update({
                     'prod_lot_id': False,
                     'prodlot_name': '',
                     'expiry_date': False,
+                    'to_correct_ok': True,
                 })
 
         if not comment:
@@ -983,7 +1009,7 @@
             if just_warn:
                 vals.update({'comment': comment, 'to_correct_ok': False})
             else:
-                vals.update({'comment': comment, 'to_correct_ok': False})
+                vals.update({'comment': comment, 'to_correct_ok': True})
 
 
         res = super(initial_stock_inventory_line, self).create(cr, uid, vals, context=context)

=== modified file 'msf_doc_import/view/initial_stock_inventory_line_view.xml'
--- msf_doc_import/view/initial_stock_inventory_line_view.xml	2013-11-18 15:25:54 +0000
+++ msf_doc_import/view/initial_stock_inventory_line_view.xml	2016-02-04 13:13:08 +0000
@@ -44,6 +44,7 @@
                         <field name="to_correct_ok" invisible="1" />
                         <field name="inactive_product" invisible="1" />
                         <field name="inactive_error" attrs="{'invisible': [('to_correct_ok', '=', False), ('inactive_product', '=,' False)]}" />
+                        <field name="inv_expiry_date" invisible="1" />
                 </xpath>
                 <xpath expr="/form/notebook/page/field[@name='inventory_line_id']/tree" position="attributes" >
                     <attribute name="colors">red:to_correct_ok ==True or has_problem == True or inactive_product == True</attribute>

=== modified file 'specific_rules/specific_rules.py'
--- specific_rules/specific_rules.py	2016-02-08 08:59:27 +0000
+++ specific_rules/specific_rules.py	2016-02-08 10:00:07 +0000
@@ -1433,9 +1433,12 @@
                 %s_line l
             WHERE
                 l.inventory_id in %%s
-            GROUP BY l.product_id, l.location_id, l.prod_lot_id, l.expiry_date
+            GROUP BY l.product_id, l.location_id, l.%s, l.expiry_date
             HAVING count(l.id) > 1
-            ORDER BY count(l.id) DESC""" % self._name.replace('.', '_')
+            ORDER BY count(l.id) DESC""" % (
+                self._name.replace('.', '_'),
+                self._name == 'stock.inventory' and 'prod_lot_id' or 'prodlot_name',
+            )
         cr.execute(sql_req, (tuple(ids),))
         check_res = cr.dictfetchall()
         if check_res:
@@ -1462,10 +1465,23 @@
 
         # treat the needed production lot
         for obj in self.browse(cr, uid, ids, context=context):
+            if obj.import_error_ok:
+                raise osv.except_osv(
+                    _('Error'),
+                    _('Plase fix issue on red lines before confirm the inventory.')
+                )
+
+            if any(l.to_correct_ok for l in obj.inventory_line_id):
+                raise osv.except_osv(
+                    _('Error'),
+                    _('Please fix issue on red lines before confirm the inventory.')
+                )
+
             for line in obj.inventory_line_id:
                 if self._name == 'initial.stock.inventory' and line.product_qty == 0.00:
                     line.write({'dont_move': True})
                     continue
+
                 if line.hidden_perishable_mandatory and not line.expiry_date:
                     raise osv.except_osv(_('Error'), _('The product %s is perishable but the line with this product has no expiry date') % product_obj.name_get(cr, uid, [line.product_id.id])[0][1])
                 if line.hidden_batch_management_mandatory and not line.prod_lot_id:
@@ -1478,8 +1494,16 @@
                 # if perishable product
                 if line.hidden_perishable_mandatory and not line.hidden_batch_management_mandatory:
                     # integrity test
-                    assert line.product_id.perishable, 'product is not perishable but line is'
-                    assert line.expiry_date, 'expiry date is not set'
+                    if not line.product_id.perishable:
+                        raise osv.except_osv(
+                            _('Error'),
+                            _('Product is not perishable but line is.')
+                        )
+                    if not line.expiry_date:
+                        raise osv.except_osv(
+                            _('Error'),
+                            _('Expiry date is not set'),
+                        )
                     # if no production lot, we create a new one
                     if not line.prod_lot_id:
                         # double check to find the corresponding prodlot
@@ -1496,8 +1520,13 @@
                             prodlot_id = prodlot_obj.create(cr, uid, vals, context=context)
                         else:
                             prodlot_id = prodlot_ids[0]
+                        prodlot_name = prodlot_obj.read(cr, uid, prodlot_id, ['name'], context=context)['name']
                         # update the line
-                        line.write({'prod_lot_id': prodlot_id,},)
+                        line.write({'prod_lot_id': prodlot_id, 'prodlot_name': prodlot_name},)
+
+                if line.prod_lot_id and not line.expiry_date:
+                    line.write({'expiry_date': line.prod_lot_id.life_date})
+
                 line_ids.append(line.id)
 
         if line_ids:
@@ -1593,7 +1622,10 @@
             expiry_date = prodlot_obj.browse(cr, uid, prod_lot_id).life_date
         else:
             expiry_date = False
-        result['value']['expiry_date'] = expiry_date
+        result['value'].update({
+            'expiry_date': expiry_date,
+            'inv_expiry_date': expiry_date,
+        })
         if expiry_date:
             prod_brw = prod_obj.browse(cr, uid, product)
             # UFTP-50: got an expiry value,
@@ -1797,14 +1829,19 @@
                    result[obj.id]['has_problem'] = True
 
             result[obj.id]['duplicate_line'] = False
-            if self.search(cr, uid, [
+            src_domain = [
                 ('inventory_id', '=', obj.inventory_id.id),
                 ('location_id', '=', obj.location_id.id),
                 ('product_id', '=', obj.product_id.id),
-                ('prod_lot_id', '=', obj.prod_lot_id and obj.prod_lot_id.id or False),
                 ('expiry_date', '=', obj.expiry_date or False),
                 ('id', '!=', obj.id),
-            ], limit=1, context=context):
+            ]
+
+            if self._name == 'initial.stock.inventory.line':
+                src_domain.append(('prodlot_name', '=', obj.prodlot_name))
+            else:
+                src_domain.append(('prod_lot_id', '=', obj.prod_lot_id and obj.prod_lot_id.id or False))
+            if self.search(cr, uid, src_domain, limit=1, context=context):
                 result[obj.id]['duplicate_line'] = True
         return result
 

=== modified file 'specific_rules/stock.py'
--- specific_rules/stock.py	2016-02-08 08:59:27 +0000
+++ specific_rules/stock.py	2016-02-08 10:00:07 +0000
@@ -119,6 +119,17 @@
 
                     self.pool.get('initial.stock.inventory.line').write(cr, uid, [inventory_line.id], {'prod_lot_id': prodlot_id}, context=context)
 
+                if inventory_line.product_id.perishable and not inventory_line.product_id.batch_management:
+                    if not inventory_line.prodlot_name and inventory_line.expiry_date:
+                        prodlot_ids = prodlot_obj.search(cr, uid, [
+                            ('type', '=', 'internal'),
+                            ('product_id', '=', inventory_line.product_id.id),
+                            ('life_date', '=', inventory_line.expiry_date),
+                        ], context=context)
+                        if prodlot_ids:
+                            self.pool.get('initial.stock.inventory.line').write(cr, uid, [inventory_line.id], {
+                                'prodlot_name': prodlot_obj.read(cr, uid, prodlot_ids[0], ['name'], context=context)['name'],
+                            }, context=context)
         
         return super(initial_stock_inventory, self).action_confirm(cr, uid, ids, context=context)
     

